#!/usr/bin/python3
# -*- coding: utf-8 -*-

import json
import os
import sys
import rsa
import dbus
import cinfo 
from cinfo import UpdateInfo
import formatconv
from datetime import datetime
BASE_DIR=os.path.dirname(os.path.dirname(os.path.abspath(__file__))) # __file__获取执行文件相对路径，整行为取上一级的上一级目录
sys.path.append(BASE_DIR) # 添加临时的路径
# print("__file__", __file__)
# print("BASE_DIR", BASE_DIR)
from kylindbus.apt_handler import AppActions, AptHandler, WorkitemError
from kylindbus.log_manager import logger

# udi = UpdateInfo()

class collect():
    def getinfo(self, udi):
        # run(debname, status)
        run(udi)

def run(udi):
    # 初始化对象
    cg = cinfo.GetUpdateInfos()
    cv = formatconv.Convert()

    # 获得IP、MachineId、uuid
    udi.update_infos['machine-id'] = cg.GetMachineId()
    udi.update_infos['ip'] = cg.GetHostIp1()
    udi.update_infos['uuid'] = cg.GenerateUUID()

    # 获取当前日期时间
    udi.update_infos['date'] = cg.GetDate()

    # 获得系统发行版本
    udi.update_infos['os-version'] = cg.GetOsVersion()

    # 获取kylin-update-manager版本
    pkgname = "kylin-update-manager"
    udi.update_infos['kum-version'] = cg.GetAppVersion(pkgname)

    # 当前更新deb包名状态
    udi.update_infos['pkg-name'] = str(udi.install_info['pkg-name'])
    udi.update_infos['status'] = str(udi.install_info['status'])

    # 获取Mac地址
    udi.update_infos['mac'] = cg.GetMacAddress1()

    # print("udi: ", udi.udi)
    # print("isi: ", udi.isi)

    # RSA加密
    enMB = cv.uniqueEnMd5Base64(udi.udi)

    # dbus发送第一组信息:update_infos
    applicationName="kylin-update-manager"
    messageType="update-infos"
    logger.info("UpdateInfos开始发送----- %s ----- ", udi.update_infos['pkg-name'])
    jsonfile = cv.ConvertJson(udi.udi).replace(" ","")
    # 调用dbus发送
    packageInfo = {}
    packageInfo = {"messageType":messageType,"packageName":"","tid":""}
    import configparser
    sendfail_pkglist = configparser.ConfigParser(allow_no_value=True)
    sendfail_pkglist.read("/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf")
    localtid = sendfail_pkglist.get("TID", "localtid")
    if localtid:
        packageInfo["tid"] = str(localtid)
    with open("/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf","w+") as f:
        sendfail_pkglist.write(f)
    localtid = sendfail_pkglist.get("TID", "localtid")
    packageInfo['packageName'] = udi.udi['update-infos']['pkg-name']

    packageInfo_json = json.dumps(packageInfo)

    UploadMessage = {}
    # UploadMessage["uploadedMessage"]["createTimeStamp"] = now_time+'.'+time_suffix
    UploadMessage["createTimeStamp"] = ""
    # for key in udi.udi['update-infos'].keys():
    #     UploadMessage[key] = udi.udi['update-infos'][key]
    UploadMessage['pkg-name'] = udi.udi['update-infos']['pkg-name']
    UploadMessage['app-name'] = applicationName
    UploadMessage['source'] = udi.udi['update-infos']['source']
    UploadMessage['status'] = udi.udi['update-infos']['status']
    UploadMessage['uuid'] = udi.udi['update-infos']['uuid']
    UploadMessage["createTimeStamp"] = get_east_8_time()

    UploadMessage_json = json.dumps(UploadMessage)
    # SHA256值
    import hashlib
    hsobj = hashlib.sha256()
    hsobj.update(UploadMessage_json.encode("utf-8"))
    enMB = cv.uniqueEnSHA256Base64(hsobj.hexdigest())
    ret,retid = sendToDbus(packageInfo_json, UploadMessage_json, enMB)
    if ret != 0: 
        udi.update_infos['sent'] = "false"
        if ret == 1:
            result = "参数格式错误"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == 2:
            udi.update_infos['sent'] = "true"
            result = "packageinfo中tid值异常，但消息存储成功"
            sendfail_pkglist = configparser.ConfigParser(allow_no_value=True)
            sendfail_pkglist.read("/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf")
            localtid = sendfail_pkglist.get("TID", "localtid")
            if not localtid:
                sendfail_pkglist.set("TID", "localtid", str(retid))
                pkglist = sendfail_pkglist.get("TID", "localtid")
            with open("/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf","w+") as f:
                sendfail_pkglist.write(f)
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == 3:
            result = "UploadedMessageSha256异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == 4:
            result = "UploadedMessageSha256解密异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == 5:
            result = "UploadedMessage中createTimeStamp字段异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
    elif ret == 0:
        udi.update_infos['sent'] = "true"
        result = "发送信息成功"
        logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
    logger.info("UpdateInfos结束发送----- %s ----- ", udi.update_infos['pkg-name'])
    # 上传失败写入本地json
    if udi.update_infos['sent'] == "false":
        cv.WriteToJson(udi.udi)

    # dbus发送第二组信息:install_info
    applicationName="kylin-update-manager"
    messageType="install-info"
    logger.info("InstallInfo开始发送----- %s ----- ", udi.install_info['pkg-name'])
    # 调用dbus发送
    packageInfo = {}
    packageInfo = {"messageType":messageType,"packageName":"","tid":""}
    import configparser
    sendfail_pkglist = configparser.ConfigParser(allow_no_value=True)
    sendfail_pkglist.read("/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf")
    localtid = sendfail_pkglist.get("TID", "localtid")
    if localtid:
        packageInfo["tid"] = str(localtid)
    with open("/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf","w+") as f:
        sendfail_pkglist.write(f)
    packageInfo['packageName'] = udi.udi['update-infos']['pkg-name']

    packageInfo_json = json.dumps(packageInfo)

    UploadMessage = {}
    UploadMessage["createTimeStamp"] = ""
    UploadMessage['pkg-name'] = udi.isi['install-info']['pkg-name']
    UploadMessage['app-name'] = applicationName
    UploadMessage['init-version'] = udi.isi['install-info']['init-version']
    UploadMessage['inst-version'] = udi.isi['install-info']['inst-version']
    UploadMessage['status'] = udi.isi['install-info']['status']
    UploadMessage['uuid'] = udi.isi['install-info']['uuid']
    UploadMessage["createTimeStamp"] = get_east_8_time()

    UploadMessage_json = json.dumps(UploadMessage)
    # SHA256值
    import hashlib
    hsobj = hashlib.sha256()
    hsobj.update(UploadMessage_json.encode("utf-8"))
    enMB = cv.uniqueEnSHA256Base64(hsobj.hexdigest())
    ret,retid = sendToDbus(packageInfo_json, UploadMessage_json, enMB)
    if ret != 0: 
        if ret == 1:
            result = "参数格式错误"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == 2:
            result = "packageinfo中tid值异常，但消息存储成功"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == 3:
            result = "UploadedMessageSha256异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == 4:
            result = "UploadedMessageSha256解密异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == 5:
            result = "UploadedMessage中createTimeStamp字段异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        # 上传失败写入本地json
        if ret != 2:
            cv.WriteToJson(udi.isi)
    elif ret == 0:
        result = "发送信息成功"
        logger.info("发送状态:true - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
    logger.info("InstallInfo结束发送----- %s ----- ", udi.install_info['pkg-name'])

def sendToDbus(packageInfo, UploadMessage, enMB):
    daqbus = dbus.SystemBus()
    daqobj = daqbus.get_object('com.kylin.daq', '/com/kylin/daq')
    daqinterface = dbus.Interface(daqobj, dbus_interface='com.kylin.daq.interface')
    retval,retid = daqinterface.UploadMessage(packageInfo, UploadMessage, enMB)

    return retval,retid

def get_east_8_time():
    import time
    # UTC时间
    utc_time = datetime.utcnow() 
    # 转时间字符串
    utc_time = utc_time.strftime("%Y-%m-%d %H:%M:%S.%f")[:-3]
    time_suffix = utc_time.split(".")[1]
    # 字符串转时间元祖
    utc_time = time.strptime(utc_time, "%Y-%m-%d %H:%M:%S.%f")
    # 时间元祖转时间戳
    utc_time = time.mktime(utc_time)
    # 生成东八区时间时间戳
    now_time = utc_time + 8*60*60
    # 时间戳转时间元祖
    now_time = time.localtime(now_time)
    # 时间元祖转字符串
    now_time = time.strftime("%Y-%m-%d %H:%M:%S",now_time)
    now_time = now_time + "." +time_suffix
    return now_time

if __name__ == "__main__":
    run()
